---
contributors:
  - ["Anna Harren", "https://github.com/iirelu"]
  - ["Marco Scannadinari", "https://github.com/marcoms"]
translators:
  - ["Ehreshi Ivan", "https://github.com/IvanEh"]
  - ["Serhii Maksymchuk", "https://github.com/Serg-Maximchuk"]
---

JSON - це надзвичайно простий формат обміну даними. Згідно з [json.org](http://json.org), для людей він легкий в написанні і читанні, а для комп’ютерів в розборі та генерації.

JSON підтримує наступні структури даних:

* Колекція пар ключ/значення (`{ "ключ": "значення" }`). У різних мовах програмування реалізується як об’єкт, запис, структура, словник, хеш-таблиця, іменований список або асоціативний масив.
* Впорядкований список значень (`[ "елемент0", "елемент1" ]`). У різних мовах програмування реалізується як масив, вектор, список або послідовність.
* Рядки: `"привіт"`, `"\"Лапки\""`, `"\u0abe"`, `"Новий рядок.\n"`
* Числа: `23`, `0.11`, `12e10`, `3.141e-10`, `1.23e+4`
* Інші: `true`, `false`, `null`

JSON в чистій формі не містить коментарів, але більшість парсерів підтримують коментарі в C-стилі (`//`, `/* */`). Деякі парсери також не звертають уваги на кому після останнього поля, але їх варто уникати для кращої сумісності.

```json
{
  "ключ": "значення",
  
  "ключі": "завжди мають бути обгорнуті в подвійні лапки",
  "числа": 0,
  "рядки": "Пρивіт, світe. Допускаються всі unicode-символи разом із \"екрануванням\".",
  "логічний тип": true,
  "нічого": null,

  "велике число": 1.2e+100,

  "об’єкти": {
    "коментар": "Більшість ваших структур будуть складатися з об’єктів",

    "масив": [0, 1, 2, 3, "масиви можуть містити будь-які типи", 5],

    "інший об’єкт": {
      "коментар": "Об’єкти можуть містити інші об’єкти. Це дуже корисно."
    }
  },

  "безглуздя": [
    {
      "джерело калію": ["банани"]
    },
    [
      [1, 0, 0, 0],
      [0, 1, 0, 0],
      [0, 0, 1, "нео"],
      [0, 0, 0, 1]
    ]
  ],
  
  "альтернативний стиль": {
    "коментар": "Гляньте!"
  , "позиція коми": "неважлива, коректно якщо вона знаходиться перед наступним полем"
  , "інший коментар": "класно"
  },

  "Це було не довго": "І ви впорались! Тепер ви знаєте все про JSON."
}

Одиничний масив значень теж є правильним JSON

[1, 2, 3, "text", true]
```
